<?php

/**
 * forma_pago actions.
 *
 * @package    cartera
 * @subpackage forma_pago
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class forma_pagoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'TS_PC_FP_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'TS_PC_FP_V' =>
        array(
            'id' => 'id',
            'codigo' => 'codigo',
            'descripcion' => 'descripcion',
            'estado' => 'estado',
            'usar_caja' => 'usar_caja',
            'usar_pos' => 'usar_pos',
            'aplica_bn' => 'aplica_bn',
            'aplica_ingresos' => 'aplica_ingresos',
            'fecha_hora_ini' => 'fecha_hora_ini',
            'fecha_hora_fin' => 'fecha_hora_fin',
            'hora_ini_text' => 'hora_ini_text',
            'hora_fin_text' => 'hora_fin_text'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'TS_PC_FP_V' => array(
            'id,a' => array('!=' => array(-1)),
            'id,b' => array('=' => array('id')),
            'usar_pos' => array('=' => array(1)),
            'aplica_bn' => array('=' => array('aplica_bn'))//,
//            'rownum,start' => array('>' => array('_startRow')),
//            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'TS_PC_FP_V' =>
        array(
            'codigo' => array('LIKE' => array('input', '%')),
            'descripcion' => array('LIKEALLPLUS' => array('input', '%'))
        )
    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'codigo'
    ); //campos para el ordenamiento de la consulta

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id'; //identificador de la tabla
    protected $id_names = array('id'); //llave primaria
    protected $field_names = array('codigo', 'descripcion', 'estado', 'usar_caja', 'usar_pos', 'aplica_bn', 'aplica_ingresos'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'TS_PC_FP'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia


    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id'; //identificador unico de la tabla

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id = $list_data_post[0]['id'];

                $hora_ini = $request['hora_ini_text'];
                $hora_fin = $request['hora_fin_text'];

                //sentencia sql ingresar CA_DEBITO
                $sql = <<<EOD
update TS_PC_FP set 
    fecha_hora_ini = to_Date( to_char(trunc(sysdate),'yyyy-mm-dd') || ' $hora_ini', 'YYYY-MM-DD HH:MI AM') ,
    fecha_hora_fin = to_Date( to_char(trunc(sysdate),'yyyy-mm-dd') || ' $hora_fin', 'YYYY-MM-DD HH:MI AM') 
    where id = (select max(id) from ts_pc_fp) 
EOD;

                //ejecuta el sql
                $this->conn->execute($sql);

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id = $request['id'];

                $hora_ini = $request['hora_ini_text'];
                $hora_fin = $request['hora_fin_text'];

                //sentencia sql ingresar CA_DEBITO
                $sql = <<<EOD
update TS_PC_FP set 
    fecha_hora_ini = to_Date( to_char(trunc(sysdate),'yyyy-mm-dd') || ' $hora_ini', 'YYYY-MM-DD HH:MI AM') ,
    fecha_hora_fin = to_Date( to_char(trunc(sysdate),'yyyy-mm-dd') || ' $hora_fin', 'YYYY-MM-DD HH:MI AM') 
    where id = $id 
EOD;

                //ejecuta el sql
                $this->conn->execute($sql);

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
